{ Ager's Socket Library (c) Copyright 1998-99 by Soren Ager (sag@poboxes.com) }
{                                                                             }
{ $Revision: 1.6 $    $Date: 1999/07/15 07:55:55 $    $Author: sag $ }
{                                                                             }
{ OO Finger Deamon example                                                    }
PROGRAM FingerD;

{$I aslDefine.Inc}
{&PMType VIO}

USES aslTCPSocket;

CONST
  Greet : String  = 'Simple Finger Daemon OO-Version'#10#13+
                    'Demo Message...';

TYPE
  TMyServer = CLASS(TTCPServerSocket)
    PROCEDURE DoLogLine(Msg: String);
  END;


  PROCEDURE TMyServer.DoLogLine(Msg: String);
  BEGIN
    WriteLn(msg);
  END;

VAR
  Svr : TMyServer;
  Cli : TTCPClientSocket;
  i   : Integer;
  Buffer : Array[0..512] of Byte;

BEGIN
  Svr:=TMyServer.Create('finger');
  Svr.OnLogLine:=Svr.DoLogLine;
  try
    repeat
      Svr.Listen;
      Cli:=Svr.AcceptConnection;
      try
        WriteLn('Connect from: '+Svr.PeerIP,' = ',Svr.PeerName);
        Cli.WaitForData;
        i:=Cli.Read(Buffer, SizeOf(Buffer));
        WriteLn('Got: ',i,' bytes.');
        i:=Cli.WriteLn(Greet);
        WriteLn('Sent:',i,' bytes');
      finally
        Cli.Destroy;
      end;
    until false;
  finally
    Svr.Destroy;
  end;
END.

